"""
    FactSet Benchmarks API

    FactSet Benchmarks API gives access to Index Constituents, Prices, Returns, and Ratios. For a sample list of identifiers, use the /metrics endpoint. Equity Only - Fixed Income Benchmark support coming soon.   # noqa: E501

    The version of the OpenAPI document: 1.9.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetBenchmarks.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetBenchmarks.exceptions import ApiAttributeError



class IndexHistory(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'fsym_id': (str, none_type,),  # noqa: E501
            'date': (date, none_type,),  # noqa: E501
            'inception_date': (date, none_type,),  # noqa: E501
            'name': (str, none_type,),  # noqa: E501
            'constituent_number': (int, none_type,),  # noqa: E501
            'currency': (str, none_type,),  # noqa: E501
            'market_value': (float, none_type,),  # noqa: E501
            'price': (float, none_type,),  # noqa: E501
            'price_return_percent': (float, none_type,),  # noqa: E501
            'total_return_level': (float, none_type,),  # noqa: E501
            'total_return_percent': (float, none_type,),  # noqa: E501
            'return_type': (str, none_type,),  # noqa: E501
            'hedge_type': (str, none_type,),  # noqa: E501
            'request_id': (str,),  # noqa: E501
            'observation_date': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'fsym_id': 'fsymId',  # noqa: E501
        'date': 'date',  # noqa: E501
        'inception_date': 'inceptionDate',  # noqa: E501
        'name': 'name',  # noqa: E501
        'constituent_number': 'constituentNumber',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'market_value': 'marketValue',  # noqa: E501
        'price': 'price',  # noqa: E501
        'price_return_percent': 'priceReturnPercent',  # noqa: E501
        'total_return_level': 'totalReturnLevel',  # noqa: E501
        'total_return_percent': 'totalReturnPercent',  # noqa: E501
        'return_type': 'returnType',  # noqa: E501
        'hedge_type': 'hedgeType',  # noqa: E501
        'request_id': 'requestId',  # noqa: E501
        'observation_date': 'observationDate',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """IndexHistory - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            fsym_id (str, none_type): Requested Identifier. Must be a valid Benchmark Identifier recognized by FactSet.. [optional]  # noqa: E501
            date (date, none_type): The respective date for values as of the date requested in YYYY-MM-DD format.. [optional]  # noqa: E501
            inception_date (date, none_type): The inception date of the requested index in YYYY-MM-DD format.. [optional]  # noqa: E501
            name (str, none_type): Proper Name of Index.. [optional]  # noqa: E501
            constituent_number (int, none_type): The total number of constituents as of the date requested.. [optional]  # noqa: E501
            currency (str, none_type): Currency Code used in adjustments. If no Currency was requested, the service will default to LOCAL ('LOC').. [optional]  # noqa: E501
            market_value (float, none_type): Index Level Market Capitalization as of the date requested expressed in millions.. [optional]  # noqa: E501
            price (float, none_type): Index Level Price. [optional]  # noqa: E501
            price_return_percent (float, none_type): Index Level Price Percent Change. [optional]  # noqa: E501
            total_return_level (float, none_type): Index Level Total Return Amount. [optional]  # noqa: E501
            total_return_percent (float, none_type): Index Level Total Return Percent Change. [optional]  # noqa: E501
            return_type (str, none_type): The requested Return Type - GROSS or NET. [optional]  # noqa: E501
            hedge_type (str, none_type): The requested Hedge Type - HEDGED or UNHEDGED. [optional]  # noqa: E501
            request_id (str): Benchmark Identifier specified in the request. [optional]  # noqa: E501
            observation_date (str, none_type): This field will always return the date of the data that was actually returned.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """IndexHistory - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            fsym_id (str, none_type): Requested Identifier. Must be a valid Benchmark Identifier recognized by FactSet.. [optional]  # noqa: E501
            date (date, none_type): The respective date for values as of the date requested in YYYY-MM-DD format.. [optional]  # noqa: E501
            inception_date (date, none_type): The inception date of the requested index in YYYY-MM-DD format.. [optional]  # noqa: E501
            name (str, none_type): Proper Name of Index.. [optional]  # noqa: E501
            constituent_number (int, none_type): The total number of constituents as of the date requested.. [optional]  # noqa: E501
            currency (str, none_type): Currency Code used in adjustments. If no Currency was requested, the service will default to LOCAL ('LOC').. [optional]  # noqa: E501
            market_value (float, none_type): Index Level Market Capitalization as of the date requested expressed in millions.. [optional]  # noqa: E501
            price (float, none_type): Index Level Price. [optional]  # noqa: E501
            price_return_percent (float, none_type): Index Level Price Percent Change. [optional]  # noqa: E501
            total_return_level (float, none_type): Index Level Total Return Amount. [optional]  # noqa: E501
            total_return_percent (float, none_type): Index Level Total Return Percent Change. [optional]  # noqa: E501
            return_type (str, none_type): The requested Return Type - GROSS or NET. [optional]  # noqa: E501
            hedge_type (str, none_type): The requested Hedge Type - HEDGED or UNHEDGED. [optional]  # noqa: E501
            request_id (str): Benchmark Identifier specified in the request. [optional]  # noqa: E501
            observation_date (str, none_type): This field will always return the date of the data that was actually returned.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
